<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document casino dice v1.0</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .picture-cover {
            background-image: url("image/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid">
        <div class="picture-cover"></div>
    </div>
    <div class="container">
        <div class="row form-group">
            <div class="col-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <input placeholder="..." class="form-control" id="inp-username">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8">
                        <input placeholder="..." class="form-control" id="inp-firstname">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8">
                        <input placeholder="..." class="form-control" id="inp-lastname">
                    </div>
                </div>
            </div>
            <div class="col-4 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <button class="btn btn-success w-75" onclick="onBtnNemClick()">Ném</button>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img src="image/dice.png" class="img-thumbnail" id="img-dice">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <p id="p-thongbao" style="display: none;">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3 text-center">
                <div class="row form-group">
                    <div class="col-12">
                        <p>Voucher</p>
                        <p id="voucherid">No ID</p>
                        <p id="percent">0%</p>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12">
                        <img class="img-thumbnail" src="image/no-present.jpg" id="prize">
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group">
            <div class="row text-center">
                <div class="col-12">
                    <button class="btn btn-primary w-25" onclick="onBtnHistoryClick()" id="btn-history">Dice History</button>
                    <button class="btn btn-primary w-25">Voucher History</button>
                    <button class="btn btn-primary w-25">Present History</button>
                </div>
            </div>
        </div>
        <div class="row form-group" id="display" style="display: none;">
            <div class="col-12">
                <table class="table table-hover table-striped border" id="table-history">
                    <thead>
                        <tr>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </tr>
                    </thead>
                    <tbody id="tbody">

                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";

    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    var gUserData = {
        username: "",
        firstname: "",
        lastname: ""
    }
    function onBtnNemClick() {

        getUserData(gUserData);
        var vDuLieuHopLe = validateData(gUserData);
        if (vDuLieuHopLe) {
            var vXmlHttpDice = new XMLHttpRequest();
            callPostNewDice(vXmlHttpDice, gUserData);
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpDice.responseText);
                    var vResponse = JSON.parse(vXmlHttpDice.responseText);
                    console.log("voucher: " + vResponse.voucher);
                    console.log("dice: " + vResponse.dice);
                    console.log("prize: " + vResponse.prize);
                    displayNewDice(vResponse);
                }
            }
        }
    }

    function onBtnHistoryClick(){
        var vBtnHistory = document.getElementById("btn-history");
        vBtnHistory.className = "btn btn-success w-25";
        console.log("Nút history được bấm");
        getUserData(gUserData);
        var vDuLieuHopLe = validateData(gUserData);
        if(vDuLieuHopLe){
        var vXmlHttpDice = new XMLHttpRequest();
        callHistoryDice(vXmlHttpDice, gUserData);
        vXmlHttpDice.onreadystatechange = function(){
            if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                var vDiceHistoryObj = JSON.parse(vXmlHttpDice.responseText);
                console.log(vDiceHistoryObj);
                displayDiceHistory(vDiceHistoryObj);
            }
        }
        }
    }

    function getUserData(paramUserObj) {
        
        paramUserObj.username = $("#inp-username").val().trim();
        paramUserObj.firstname = $("#inp-firstname").val().trim();
        paramUserObj.lastname = $("#inp-lastname").val().trim();
    }

    function validateData(paramUserObj) {
        if (paramUserObj.username == "") {
            alert("Vui lòng nhập username");
            return false;
        }
        if (paramUserObj.firstname == "") {
            alert("Vui lòng nhập firstname");
            return false;
        }
        if (paramUserObj.lastname == "") {
            alert("Vui lòng nhập lastname");
            return false;
        }
        return true;
    }

    function callPostNewDice(paramXmlHttp, paramUserObj) {
        const vBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
        const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
        paramXmlHttp.open("POST", vBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramUserObj));
    }

    function displayNewDice(paramNewDice) {
        var vImgDice = $("#img-dice");
        var vNotice = $("#p-thongbao");
        var vDisplayVoucherId = $("#voucherid");
        var vPercentVoucher = $("#percent");
        var vPize = $("#prize");

        vNotice.show();
        if (paramNewDice.dice == 1) {
            vImgDice.prop("src", "image/1.png");
        }
        if (paramNewDice.dice == 2) {
            vImgDice.prop("src", "image/2.png");
        }
        if (paramNewDice.dice == 3) {
            vImgDice.prop("src", "image/3.png");
        }
        if (paramNewDice.dice == 4) {
            vImgDice.prop("src", "image/4.png");
        }
        if (paramNewDice.dice == 5) {
            vImgDice.prop("src", "image/5.png");
        }
        if (paramNewDice.dice == 6) {
            vImgDice.prop("src", "image/6.png");
        }
        if (paramNewDice.voucher !== null) {
            vDisplayVoucherId.show();
            vPercentVoucher.show();
            vDisplayVoucherId.html(paramNewDice.voucher.maVoucher);
            vPercentVoucher.html(paramNewDice.voucher.phanTramGiamGia + "%");


        }
        if (paramNewDice.voucher == null) {
            vDisplayVoucherId.html("No ID");
            vPercentVoucher.html("0%");

        }

        if (paramNewDice.prize == "Mũ") {
            vPize.prop("src", "image/hat.jpg");
        }
        if (paramNewDice.prize == "Áo") {
            vPize.prop("src", "image/t-shirt.jpg");
        }
        if (paramNewDice.prize == "Ô tô") {
            vPize.prop("src", "image/car.jpg");
        }
        if (paramNewDice.prize == "Xe máy") {
            vPize.prop("src", "image/motobike.jpg");
        }
        if (paramNewDice.prize == "Xe đạp") {
            vPize.prop("src", "image/bike.jpg");
        }
        if(paramNewDice.prize == null) {
            vPize.prop("src", "image/no-present.jpg");
        }
    }
</script>

</html>